clear all
clc
%%%%%%%%%%%%% Pierre Perron and Tatsuma Wada (2005) %%%%%%%%%%%%%%%%%%%%%%
%
% Trend and Cycles: A New Approach and Explanations of Some Old Puzzles
%
%  Estimation, Filtering, and Smoothing program
%  This also generates Figures 3.    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



%Real GDP 1947.1 - 1998.2; From CITI
data=load('lngdpq.txt');
global START; 
global T;
global yy;


%randn('state',4648)  % s:\fourstates\findmax_05_(initial1).mat; 

START=2;

y= 100*data;
yy=diff(y);

T=length(yy);
t=1:T;



param=[0.00036402 0.25834537 1.28155524 0.00007377 0.06340230 1.37998431 -0.47186650 0.58131935 0.90000207 0.24966417];
[cycle,s] = filtering_diff4(yy,param);
trend=y(2:206)-cycle(:,2)-cycle(:,4); % filtered trend
%trend=y(2:206)-s(:,2)-s(:,4);         % smoothed trend




 year=1947.25:.25:1998.25;
 %year=1947.25:.25:2004.25;

 %save s:\fourstates\fourstatestrend2 cycle; 

% Business cycle dates NBER
b1p=1948.75;b1t=1949.75;
b2p=1953.50;b2t=1954.25;
b3p=1957.50;b3t=1958.25;
b4p=1960.25;b4t=1961.00;
b5p=1969.75;b5t=1970.75;
b6p=1973.75;b6t=1975.00;
b7p=1980.00;b7t=1980.50;
b8p=1981.50;b8t=1982.75;
b9p=1990.50;b9t=1991.00;
b10p=2001.00;b10t=2001.75;


bs1=[b1p,b1p,b1t,b1t]';
bs2=[b2p,b2p,b2t,b2t]';
bs3=[b3p,b3p,b3t,b3t]';
bs4=[b4p,b4p,b4t,b4t]';   
bs5=[b5p,b5p,b5t,b5t]';
bs6=[b6p,b6p,b6t,b6t]';
bs7=[b7p,b7p,b7t,b7t]';
bs8=[b8p,b8p,b8t,b8t]';
bs9=[b9p,b9p,b9t,b9t]';
bs10=[b10p,b10p,b10t,b10t]';

BS=[bs1,bs2,bs3,bs4,bs5,bs6,bs7,bs8,bs9,bs10];

mi=-2;
ma=2;
m=[ma,mi,mi,ma];
mint=720;
maxt=900;
%maxt=950;
minc=-10;
maxc=10;



set(0,'lang','english')
set(0,'DefaultFigurePaperType','a4letter') 
set(0,'DefaultFigurePaperOrientation','Landscape');
set(0,'DefaultFigurePaperPositionMode','auto');
set(0,'defaultAxesFontName','arial');
set(0,'defaultTextFontName','arial');


% call HP and BP filtered cycles;
hpf16=load('hpf16.txt');
hpf80=load('hpf80.txt');
byf=load('byf.txt');



%Plot Cycles
m=[maxc,minc,minc,maxc];
lz=zeros(1,length(year));

figure 
for q=1:10
fill(BS(:,q),m,'y');hold on;
end
plot(year,s(:,2),year,lz)
%title('Cycle')
axis([1947.25,1998.25,minc,maxc])
%axis([1947,2004.25,minc,maxc])
xlabel('year')
ylabel('Deviation (%)')











figure 
for q=1:10
fill(BS(:,q),m,'y');hold on;
end
plot(year,cycle(:,2),year,lz)
%title('Cycle')
axis([1947.25,1998.25,minc,maxc])
%axis([1947,2004.25,minc,maxc])
xlabel('year')
ylabel('Deviation (%)')


% Plot Trends


trend=y(2:206)-cycle(:,2)-cycle(:,4); % filtered trend
trends=y(2:206)-s(:,2)-s(:,4);         % smoothed trend
cycle=trend;




figure
plot(year,trend,'-','LineWidth',1);  hold on;
%plot(year,y(2:230),':')
plot(year,y(2:206),':')
%title('Filtered trend: Non-Gaussian')
legend('Trend','Data')
axis([1947.25,1998.25,mint,maxt])
%axis([1947,2004.25,mint,maxt])
xlabel('year')

figure
plot(year,trends,'-','LineWidth',1);  hold on;
%plot(year,y(2:230),':')
plot(year,y(2:206),':')
%title('Filtered trend: Non-Gaussian')
legend('Trend','Data')
axis([1947.25,1998.25,mint,maxt])
%axis([1947,2004.25,mint,maxt])
xlabel('year')


% Figure 5

figure
subplot(2,2,1)
for q=1:10
fill(BS(:,q),m,'y');hold on;
end
plot(year,s(:,2),':',year,lz,year,hpf16(2:206))
title('HP filter 1600')
axis([1947.25,1998.25,minc,maxc])
%axis([1947,2004.25,minc,maxc])
xlabel('year')
ylabel('Deviation (%)')


subplot(2,2,2)
for q=1:10
fill(BS(:,q),m,'y');hold on;
end
plot(year,s(:,2),':',year,lz,year,byf(2:206))
title('Band Pass Filter')
axis([1947.25,1998.25,minc,maxc])
%axis([1947,2004.25,minc,maxc])
xlabel('year')
ylabel('Deviation (%)')


subplot(2,2,3)
for q=1:10
fill(BS(:,q),m,'y');hold on;
end
plot(year,s(:,2),':',year,lz,year,hpf80(2:206))
title('HP Filter 800,000')
axis([1947.25,1998.25,minc,maxc])
%axis([1947,2004.25,minc,maxc])
xlabel('year')
ylabel('Deviation (%)')


