clear all

% Simulation
% Simulation
% Parameters Setting
% phi1=1.28
% phi2=-0.38
% mu=0.95
%  d=-0.29
% const=724.18
% sige=0.94

warning off;


randn('state', 4648)

global START; 
global T;
global yy;


T1=200+5;
I=101+5; % break happens at t=100;
START=2;
t=1:T1; % deterministic trend
t=t';


rep=200; % number of replication


It=zeros(1,T1);
It(1,I:T1)=1:T1-I+1;
It=It';


b=.95;
%d=0;

%D=0:-.1:-1.5;


D=[-.1,-.4,-.6,-0.29];
ld=length(D);

Pmean=zeros(6,ld);
Pmedian=zeros(6,ld);
Psd=zeros(6,ld);

Value=zeros(ld,rep,1);

for i=1:ld     
d=D(i);

redo=0;

PRM=zeros(6,rep);
Eflag=zeros(rep,1);
Fval=zeros(rep,1);


while redo<rep
%redos=12;
%redos=58; 

%for redo=1:100
  
    
% data generation

e=zeros(T1,1);
e=.94*randn(T1,1);

% making cyclical components
eph1=1.28;
eph2=-.38;

c=zeros(1,T1);

c(1)=e(1);
c(2)=eph1*c(1)+e(2);

for j=3:T1
    c(j)=eph1*c(j-1)+eph2*c(j-2)+e(j);
end
c=c';

yy=zeros(T1,1);
yy=724.18+b*t+d*It+c;  % DGP

yy=yy(6:T1);
T=length(yy);
%estimation

%if redo>=redos
    prmtr_in=[0.3721,0.4782,0,0.8199,3.258,-1.9541];
    prmtr_in=[0.3720,0.4783, 0,  0.8119, 3.2581, -1.9566]; 
    options=optimset('MaxFunEvals',[],'maxiter',[],'LargeScale','off','display','off','TolX',1e-6);
    
    
    [xout_uc0,fval,exitflag,output,grad,hess]=fminunc(@lik_fcn_uc0_m11,prmtr_in,options);%
    prmtr_f=trans_uc0_m11(xout_uc0)';
    fval
    hess;
    exitflag
    
        if fval==0
            exitflag=0;
            22
        end
        
         if rcond(hess)<eps
             exitflag=0;
             11
         end

        exitflag
        
    
    

% end
% end
% end
% break
  
    if exitflag>0
        redo=redo+1;
        PRM(:,redo)=prmtr_f;
        Eflag(redo,1)=exitflag;
        Fval(redo,1)=fval;
        
        %making residuals
        ct=zeros(T,2);
        ct=filter_uc0_m11(xout_uc0); % filtered process trend and cycle
        lc=length(ct);
        eta=ct(2:lc,1)-ct(1:lc-1,1)-prmtr_f(4);  % residual of trend
        eps=ct(3:lc,2)-prmtr_f(5)*ct(2:lc-1,2)-prmtr_f(6)*ct(1:lc-2,2); % residual of cycle
        
        ETA(:,redo)=eta(2:T-2);
        EPS(:,redo)=eps;
        Trend(:,redo)=ct(:,1); %filtered process trend
        Cycle(:,redo)=ct(:,2); %filtered process cycle
        Y(:,redo)=yy;
    end
        
        [d,redo]
        %end
end

Value(i,:,:)=Fval;

Pmean(:,i)=mean(PRM,2);
Pmedian(:,i)=median(PRM,2);
Psd(:,i)=std(PRM,0,2);


ETAmedian(:,i)=median(ETA,2);
EPSmedian(:,i)=median(EPS,2);
Cyclemd=median(Cycle,2); 
Trendmd=median(Trend,2);


correlation=corrcoef(ETAmedian(:,i),EPSmedian(:,i));
TCcorrelation=corrcoef(Trendmd,Cyclemd);



before_eta=mean(ETAmedian(1:97,i));
after_eta=mean(ETAmedian(98:197,i));

before_eps=mean(EPSmedian(1:97,i));
after_eps=mean(EPSmedian(98:197,i));
end

AETA=mean(ETAmedian,1);
AEPS=mean(EPSmedian,1);

leta=1:length(ETAmedian);
leps=1:length(EPSmedian);

lt=1:length(Trendmd);

% figure
% subplot(2,1,1)
% plot(leta,ETAmedian)
% title('UC0 residual trend')
% 
% subplot(2,1,2)
% plot(leps,EPSmedian)
% title('UC0 residual cycle')
% %axis([1,T-2,-.4,.4])
% 
% figure
% % subplot(2,1,1)
% plot(lt,Trendmd)
% title('UC0 Trend')
% 
% figure
% % subplot(2,1,2)
% plot(lt,Cyclemd)
% title('UC0 Cycle')
% axis([1,T-2,-6,6])
% 
% figure
% plot(leta,ETAmedian,leps,EPSmedian)
% title('UC0 residual')
% legend('trend','cycle')
% axis([1,T-2,-.4,.4])
% 
% 
% 
% 
% 
% 
% 
% 
% 
% 
% 
% 
% 
% 
% 
% figure
% plot(leta,ETAmedian)
% title('UC0 residual trend')
% axis([0,T,-.4,.4])
% 
% figure
% plot(leps,EPSmedian)
% title('UC0 residual cycle')
% axis([0,T,-.4,.4])
% 
% figure
% plot(leta,ETAmedian,leps,EPSmedian)
% title('UC0 residual')
% legend('trend','cycle')
% axis([0,T,-.4,.4])
% 


%save ('S:\Project_m11\simulation\uc0_final')

