clear all

% Simulation
% Parameters Setting
% phi1=1.28
% phi2=-0.38
% mu=0.95
%  d=-0.29
% const=724.18
% sige=0.94

warning off;
format short;
randn('state', 4648)

global START; 
global T;
global yy;

T1=200+5;
I=101+5; % break happens at t=100;
START=2;
t=1:T1; % deterministic trend
t=t';

rep=2; % number of replication


It=zeros(1,T1);
It(1,I:T1)=1:T1-I+1;
It=It';

b=1;
b=.95;

D=[-.1,-.4,-.6,-0.29];
ld=length(D);
re=197; %length of eta



Pmean=zeros(6,ld);
Pmedian=zeros(6,ld);
Psd=zeros(6,ld);

before_eta=zeros(ld,1);
after_eta=zeros(ld,1);

before_eps=zeros(ld,1);
after_eps=zeros(ld,1);

ETAmedian=zeros(re,ld);
EPSmedian=zeros(re,ld);

for i=4:ld
       
d=D(i);

redo=0;

PRM=zeros(6,rep);
Eflag=zeros(rep,1);
Fval=zeros(rep,1);

ETA=zeros(re,rep);
EPS=zeros(re,rep);

while redo<rep   
% data generation
e=zeros(T1,1);
e=.94*randn(T1,1);

% making cyclical components
eph1=1.28;
eph2=-.38;

c=zeros(1,T1);

c(1)=e(1);
c(2)=eph1*c(1)+e(2);

for j=3:T1
    c(j)=eph1*c(j-1)+eph2*c(j-2)+e(j);
end
c=c';

yy=zeros(T1,1);
yy=724.18+b*t+d*It+c;  % DGP
yy=yy(6:T1);
T=length(yy);

%estimation
    prmtr_in=[0.6484,0.2895,-1.1209,0.8156,2.0389,0.1190];
    prmtr_f=zeros(6,1);
    options=optimset('MaxFunEvals',[],'maxiter',[],'LargeScale','off','display','off','TolX',1e-6);
    [xout_ucur,fval,exitflag,output,grad,hess]=fminunc(@lik_fcn_m11,prmtr_in,options);%
    prmtr_f=trans_m11(xout_ucur)';
    fval
    hess;
    exitflag
    
        if fval==0
            exitflag=0;
            22
        end
        
         if rcond(hess)<eps
             exitflag=0;
             11
         end

        exitflag  

    if exitflag>0
        redo=redo+1;
        PRM(:,redo)=prmtr_f;
        Eflag(redo,1)=exitflag;
        Fval(redo,1)=fval;
        
        %making residuals
        ct=zeros(T,2);
        ct=filter_uc_ur_m11(xout_ucur); % filtered process trend and cycle
        lc=length(ct);
        eta=ct(2:lc,1)-ct(1:lc-1,1)-prmtr_f(4);  % residual of trend
        epsilon=ct(3:lc,2)-prmtr_f(5)*ct(2:lc-1,2)-prmtr_f(6)*ct(1:lc-2,2); % residual of cycle
        
        ETA(:,redo)=eta(2:T-2);  % From 2 or 1?
        EPS(:,redo)=epsilon;
        Trend(:,redo)=ct(:,1); %filtered process trend
        Cycle(:,redo)=ct(:,2); %filtered process cycle
        Y(:,redo)=yy;
        
    end
        %redo=sum(Eflag)%+redos-1; % changed
        
        [d, redo]
     
end

Pmean(:,i)=mean(PRM,2);  % mean or median
Pmedian(:,i)=median(PRM,2);
Psd(:,i)=std(PRM,0,2);

ETAmedian(:,i)=median(ETA,2);
EPSmedian(:,i)=median(EPS,2);

% Cyclemd=median(Cycle,2); 
% Trendmd=median(Trend,2);


% correlation=corrcoef(ETAmedian(:,i),EPSmedian(:,i));
% TCcorrelation=corrcoef(Trendmd,Cyclemd);
redo=0;

before_eta(i)=mean(ETAmedian(1:97,i));
after_eta(i)=mean(ETAmedian(98:197,i));

before_eps(i)=mean(EPSmedian(1:97,i));
after_eps(i)=mean(EPSmedian(98:197,i));

end
AETA=mean(ETAmedian,1);
AEPS=mean(EPSmedian,1);




% End of the Simulation

% leta=1:length(ETAmedian);
% leps=1:length(EPSmedian);
% 
% lt=1:length(Trendmd);

% figure
% subplot(2,1,1)
% plot(leta,ETAmedian)
% title('UCUR residual trend')
% 
% subplot(2,1,2)
% plot(leps,EPSmedian)
% title('UCUR residual cycle')
% %axis([1,T-2,-.4,.4])
% 
% figure
% %subplot(2,1,1)
% plot(lt,Trendmd)
% title('UCUR Trend')
% 
% %subplot(2,1,2)
% figure
% plot(lt,Cyclemd)
% title('UCUR Cycle')
% axis([1,T-2,-6,6])
% 
% figure
% plot(leta,ETAmedian,leps,EPSmedian)
% title('UCUR residual')
% legend('trend','cycle')
% axis([1,T-2,-.4,.4])

%save ('S:\Project_m11\simulation\ucur_final')
